SystemOrganization addCategory: #'Manifest-CriticBrowser'!

!RBCompositeLintRule methodsFor: '*Manifest-CriticBrowser' stamp: 'StephaneDucasse 11/21/2012 18:25'!
removeRule: aRule

	(rules anySatisfy: [ :rule | rule name = aRule name] )
		ifTrue: [rules := rules reject:  [ :rule | rule name = aRule name]]
		 ifFalse: [rules do: [ :rule |
				rule isComposite 
					ifTrue: [rule removeRule: aRule]]] ! !

!RBCompositeLintRule methodsFor: '*Manifest-CriticBrowser' stamp: 'StephaneDucasse 11/21/2012 18:25'!
sort: aBlock
	
	rules first isComposite
		 ifTrue: [ rules do: [ :rule | rule sort: aBlock ]] 
		ifFalse: [ self rules: (rules sort: aBlock) ]! !

ComposableModel subclass: #CommentWindow
	instanceVariableNames: 'okCancelToolBarModel commentInputFieldModel rule critic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CommentWindow commentStamp: '<historical>' prior: 0!
A simple dialog to get a comment for the situation.!

CommentWindow subclass: #CommentFalsePositiveWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CommentFalsePositiveWindow commentStamp: '<historical>' prior: 0!
To enter comment for false positives.!

!CommentFalsePositiveWindow class methodsFor: 'instance creation' stamp: 'StephaneDucasse 11/21/2012 17:49'!
openOnCritic: aCritc onRule: aRule
	
	self new
		critic: aCritc;
		rule: aRule;
		initializeForFalsePositive;		
		openWithSpec. ! !

!CommentFalsePositiveWindow methodsFor: 'initialization' stamp: 'SimonAllier 2/1/2013 15:06'!
initializeForFalsePositive
	self initializeTextForFalsePositive.
	
	okCancelToolBarModel okAction: [ | manifestBuilder rId rV|
		rId :=  rule class uniqueIdentifierName.
		rV :=   rule class identifierMinorVersionNumber.
		manifestBuilder := BuilderManifest of: critic.
		
		(manifestBuilder hasFalsePositiveOf: rId version: rV) 
			ifFalse: [manifestBuilder installFalsePositiveOf: rId version: rV].
		
		manifestBuilder
			addFalsePositive: critic  withComment:  (commentInputFieldModel getText)  of: rId version: rV]! !

!CommentFalsePositiveWindow methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 16:43'!
initializeTextForFalsePositive
	| ruleId versionId  manifestBuilder|
	manifestBuilder := BuilderManifest of: critic.
	ruleId :=  rule class uniqueIdentifierName. 
	versionId := rule class identifierMinorVersionNumber.
	
	(manifestBuilder hasFalsePositiveOf: ruleId version: versionId)
		ifFalse: [^ self] .
	
	commentInputFieldModel text: ((BuilderManifest of: critic) commentOfFalsePositive: critic onRule: ruleId version: versionId)  ! !

!CommentFalsePositiveWindow methodsFor: 'initialization' stamp: 'Sd 11/30/2012 16:43'!
initializeWidgets

	^ #()! !

CommentWindow subclass: #CommentToDoWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CommentToDoWindow commentStamp: '<historical>' prior: 0!
To enter comment for todos.!

!CommentToDoWindow class methodsFor: 'instance creation' stamp: 'StephaneDucasse 11/21/2012 17:49'!
openOnCritic: aCritc onRule: aRule
	
	self new
		critic: aCritc;
		rule: aRule;
		initializeForToDo;		
		openWithSpec. ! !

!CommentToDoWindow methodsFor: 'initialization' stamp: 'SimonAllier 2/1/2013 15:06'!
initializeForToDo
	self initializeTextForToDo.
	
	okCancelToolBarModel okAction: [ | manifestBuilder rId rV|
		rId :=  rule class uniqueIdentifierName.
		rV :=   rule class identifierMinorVersionNumber.
		manifestBuilder := BuilderManifest of: critic.
		
		(manifestBuilder hasToDoOf: rId version: rV) 
			ifFalse: [manifestBuilder installToDoOf: rId version: rV].
		
		manifestBuilder
			addToDo: critic  withComment:  (commentInputFieldModel getText)  of: rId version: rV]! !

!CommentToDoWindow methodsFor: 'initialization' stamp: 'SimonAllier 2/1/2013 15:06'!
initializeTextForToDo

	| ruleId versionId  manifestBuilder|
	manifestBuilder := 	BuilderManifest of: critic.
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	(manifestBuilder hasToDoOf: ruleId version: versionId)
		ifFalse: [^ self] .
	commentInputFieldModel text: ((BuilderManifest of: critic) commentOfToDo: critic onRule: ruleId version: versionId)  ! !

!CommentWindow class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 13:29'!
defaultSpec
	
	^ { #Panel.
			#useProportionalLayout.
			#add:. {{#model .	#commentInputField }	. #layout: .  #(FrameLayout
																			bottomOffset: -25)}.
			#add:. {{#model.	#okCancelToolBar }	. #layout:.  #(FrameLayout
																			topFraction: 1
																			topOffset: -25)} .
			#hSpaceFill .
			#vSpaceFill }! !

!CommentWindow class methodsFor: 'specs' stamp: 'SimonAllier 3/30/2012 15:04'!
title
	^ 'Comment'! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 14:58'!
commentInputField
	^ commentInputFieldModel! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 15:50'!
critic: aCritic
	critic := aCritic! !

!CommentWindow methodsFor: 'protocol' stamp: 'StephaneDucasse 11/21/2012 17:48'!
initialExtent

	^  (465@225)! !

!CommentWindow methodsFor: 'initialization' stamp: 'SimonAllier 5/9/2012 16:42'!
initialize

	super initialize.
	
	okCancelToolBarModel := self instantiate: OkCancelToolbar. 
	commentInputFieldModel := self instantiate: TextModel.
	
	"commentInputFieldModel removeEntryCompletion "
	! !

!CommentWindow methodsFor: 'initialization' stamp: 'Sd 11/29/2012 14:37'!
initializeWidgets
	^ self ! !

!CommentWindow methodsFor: 'protocol' stamp: 'SimonAllier 3/30/2012 16:02'!
okAction: aBlock
	^ okCancelToolBarModel okAction: aBlock! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 14:58'!
okCancelToolBar
	^ okCancelToolBarModel! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 15:50'!
rule: aRule
	rule := aRule! !

ComposableModel subclass: #CriticBrowser
	instanceVariableNames: 'criticModel rulesModel checker thread title rbEnvironment removeTestCase cache resetButton logButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticBrowser commentStamp: '<historical>' prior: 0!
I am a browser for the SmallLint Critics

Example: 


| rule environment |
rule :=  RBExcessiveArgumentsRule new.
environment := (RBPackageEnvironment new packages: {RPackageSet named: 'Manifest-Core'}).

(CriticBrowser openOnRule: rule onEnvironment: environment)
	
!

!CriticBrowser class methodsFor: 'menu' stamp: 'SimonAllier 2/1/2013 15:19'!
criticsBrowserMenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: 'Critic Browser')
		action: [ self openOnCurrentWorkingConfiguration];
		order: 10;
		parent: #Tools;
		help: 'To manage rule checks';
		icon: self icon! !

!CriticBrowser class methodsFor: 'specs' stamp: 'SimonAllier 2/8/2013 16:11'!
defaultSpec
	<spec>
	
	^ SpecLayout composed 
		newColumn: [:c |
			c 
				newRow: [:r |
					r 
						newColumn: [:c1 |
							c1 add: #rulesModel.
							c1 newRow: [:c2 |
								c2 add: #resetButton.
								c2 add: #logButton
							] height: 25
						];
						newColumn: [:c1 |
							c1 
								add: #(criticModel textInputFieldModel) height: 20;
								add: #(criticModel criticsModel);
								add: #(criticModel toolbarModel) height: 25 ]];
				addSplitter;
				add: #(criticModel textModel) ]! !

!CriticBrowser class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 11/24/2012 17:30'!
icon
	"Answer an icon for the receiver."
	
	^ self theme smallWarningIcon! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 8/1/2012 11:03'!
open

	| env rules  |
	rules :=  RBCompositeLintRule allGoodRules rules.
	env := (RBPackageEnvironment new packages: ((MCWorkingCopy  allManagers asOrderedCollection) copyFrom: 1 to: 20)).
	
	self openOnRule: rules onEnvironment:  env
	

	.! !

!CriticBrowser class methodsFor: 'menu' stamp: 'SimonAllier 2/1/2013 15:31'!
openOnCurrentWorkingConfiguration

	CriticWorkingConfiguration exists
		ifTrue: [  ResetWindow new openWithSpec  ]
		ifFalse: [ SelectPackageBrowser open]! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 1/30/2013 10:43'!
openOnRule: aRule onEnvironment: aEnv

	| cbr |
	cbr :=  self new rules: aRule;
		environment: aEnv;
		removeTestCase: false;
		yourself.

	cbr openWithSpec.
	cbr applyRules. 
	cbr rulesModel  changed:  #listElementAt:.! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 1/21/2013 17:03'!
openOnWorkspace: aWorkspace

	| cbr |
	cbr :=  self new 
		rules: aWorkspace rule;
		environment: aWorkspace environment;
		removeTestCase: aWorkspace removeTestCase;
		yourself.

	cbr openWithSpec.
	cbr applyRules. 
	cbr rulesModel  changed:  #listElementAt:.! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'MikeMueller 3/4/2013 15:01'!
packagesGroup: aBuilder
	<nautilusGlobalGroupMenu>
	(aBuilder item: #'Critics Browser')
		action: [ 
					| packages target env rules group |
					target := aBuilder model.
					group := target selectedGroups.
					packages := OrderedCollection new.
					group
						do: [ :each | each classes do: [ :cl | MCWorkingCopy managersForClass: cl do: [ :package | packages add: package ] ] ].
					rules := RBCompositeLintRule allGoodRules.
					env := RBPackageEnvironment new packages: packages.
					self openOnRule: rules onEnvironment: env ];
		help: 'Running critics rules on this group'! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'MikeMueller 3/4/2013 15:01'!
packagesMenu: aBuilder
	<nautilusGlobalPackageMenu>
	(aBuilder item: #'Critics Browser')
		action: [ 
					| packages target env rules |
					target := aBuilder model.
					packages := OrderedCollection new.
					target selectedPackages
						do: [ :p | MCWorkingCopy managersForCategory: p packageName do: [ :package | packages add: package ] ].
					rules := RBCompositeLintRule allGoodRules.
					env := RBPackageEnvironment new packages: packages.
					self openOnRule: rules onEnvironment: env ];
		help: 'Running critics rules on this package'! !

!CriticBrowser class methodsFor: 'menu' stamp: ''!
theme
	^ UITheme current! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 1/25/2013 16:23'!
InspectResult

	rulesModel selectedItem ifNotNil: [:rule | Inspector openOn: rule result]! !

!CriticBrowser methodsFor: 'user interface' stamp: 'SimonAllier 2/1/2013 15:11'!
addModelItemsToWindowMenu: aMenu
	"Add model-related items to the window menu"

	"super addModelItemsToWindowMenu: aMenu."

	aMenu
		addLine;
		add: 'Clean all manifest' translated target: checker action: #cleanAllManifest;
		add: 'Reapply all  rules' translated target: self action: #reapplyAllRules! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 1/31/2013 11:50'!
addRuleToFalsePositive
	rulesModel selectedItem ifNotNil: [ :rule |
		rule leaves do: [: r |
			rbEnvironment packages do: [:package |
				cache addFalsePositiveRule: r forPackage: package]]].
	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/8/2013 13:33'!
applyRules

	|  packageCount nbPackage process rules|	
	rules := rulesModel getRoots first. 
	rules resetResult.
	nbPackage := rbEnvironment packages size.
	packageCount := 0.
	self updateTree.
	process := [  
		rbEnvironment packages do: [:package ||  windowTitle |
			
			packageCount := packageCount + 1.
			windowTitle := String streamContents: [:s | 
				s 
					<< 'run rules on '
					<< package packageName
					<< ' ('
					<< packageCount asString
					<< '/'
					<< nbPackage asString
					<< ')' ].				
			self setTitle: windowTitle.
			package packageSet packages do: [:RPa |
				checker runRules: rules onPackage: RPa withoutTestCase: removeTestCase] ].
		checker rule: rules.
		self setTitle: 'Critics Browser'.
		cache packages: rbEnvironment.
		cache initCache. 
		self updateTree.
		
		self registerToAnnouncements ] newProcess.
	
	process name: 'SmallLint'.
	process resume.
! !

!CriticBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/24/2012 16:43'!
browseRule

	rulesModel selectedItem ifNotNil: [:rule | rule browse ]! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 1/23/2013 14:42'!
classModified: anAnnouncement
	"checks if a modification of a class fixes a warning. if true,  the true/false positives in the browser are update"
	
	|  class  |
	
	
	class := anAnnouncement class.
	class isManifest ifTrue: [ ^ self ].	
	
	(criticModel criticsModelContains: anAnnouncement classAffected) ifFalse: [^ self].
	
	self reapplyThisRule	! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 1/31/2013 14:09'!
classRemoved: anAnnouncement
	((rbEnvironment packages gather: [:package | package packageSet packages])
		classes anySatisfy: [ :cl | anAnnouncement classRemoved = cl ]) 
			ifFalse: [ ^ self ].
	
	cache itemRemoved: anAnnouncement classRemoved! !

!CriticBrowser methodsFor: 'accessing' stamp: ''!
criticModel
	^ criticModel! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/24/2013 12:55'!
environment
	^ rbEnvironment
! !

!CriticBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 12/22/2012 19:41'!
environment: aEnv
	rbEnvironment := aEnv
! !

!CriticBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/24/2012 17:18'!
initialExtent

	^   760@370! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/5/2013 11:39'!
initialize
	"Initialization code for CriticRulesBrowser"
	
	super initialize.
	cache := CriticsCache new.
	checker := SmalllintManifestChecker new.
	cache checker: checker.
	cache browser: self. 
	criticModel cache: cache.	
		



! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 16:30'!
initializeDisplayBlockForRules

	rulesModel displayBlock: [:rule || falsePositives toDos total text unknown |
		falsePositives := (cache falsePositiveOf: rule) size.
		toDos :=(cache toDosOf: rule) size.
		total :=  (cache criticsOf: rule) size. 
		unknown  := total - falsePositives - toDos.
		text := String streamContents: [:s |
			s 
				<< rule name 
				<< ' (FP: ' 
				<< falsePositives asString 
				<< ', ToDo: '
				<< toDos asString 
				<< ', Unclassfied: ' 
				<<  unknown asString 
				<<  ')' ].
		total isZero
			ifTrue: [ text ] 
			ifFalse: [
				falsePositives >= total
					ifTrue: [ text asText makeAllColor: criticModel falsePositiveColor ]
					ifFalse: [ text asText makeAllColor: criticModel defaultColor ]]]! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/5/2013 11:40'!
initializePresenter

	rulesModel whenSelectedItemChanged: [:rule |
		(rule isNil or: [ rule isComposite ]) ifFalse: [
			criticModel resetSelection.
	 		criticModel rule: rule. 	
			criticModel setTextModelForNil]].

! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 1/29/2013 15:38'!
initializeWidgets
	
	title := 'Critic Browser'.
	rulesModel := self instantiate: TreeModel.
	self instantiateModels: #(
		rulesModel TreeModel
		resetButton  ButtonModel 
		logButton ButtonModel ).
	
	
	self setLogButton.
	self setResetButton.
	 
	criticModel := SingleRuleCriticBrowser new.
	rulesModel childrenBlock: [:rule | 
		rule isComposite 
			ifTrue: [ rule rules ]
			ifFalse: [ #() ]]. 

	rulesModel menu: [:a :b | self menu: a shifted: b ].	
	self initializeDisplayBlockForRules.
	
	self focusOrder
		add: rulesModel;
		add: criticModel! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/29/2013 15:27'!
logButton
	^ logButton ! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 1/25/2013 16:23'!
logInManifest
	cache logInManifest! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 2/1/2013 16:35'!
menu: aMenu shifted: aBoolean

	aMenu
		add: 'Browse rule' translated
			target: self
			selector: #browseRule;
		add: 'Inspect result of this rule' translated
			target: self
			selector: #InspectResult;
		"add: 'Do not understand this rule' translated
			target: self
			selector: #doNotUnderstandThisRule;
		add: 'This rule contains a bug' translated
			target: self
			selector: #bugRule;"
		add: 'Reapply this rule'
			target: self
		selector: #reapplyThisRule;
		addLine;
		add: 'Ban this rule for all packages' translated
			target: self
			selector: #addRuleToFalsePositive;
		add: 'Unban this rule for all packages' translated
			target: self
			selector: #removeRuleToFalsePositive;
		addLine. 
		"add: 'Reset working package sets' translated
			target: self
			selector: #resetWorkingConfiguration."
	 ^ aMenu! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 8/13/2012 10:26'!
methodAdded: anAnnouncement
	anAnnouncement methodClass isManifest
		ifFalse: [ ^ self ].
	self updateCountOf: rulesModel selectedItem.
	self updateTree! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 1/23/2013 18:13'!
methodModified: anAnnouncement
"checks if a modification of a method fixes a warning. if true,  the true positives in the browser are update"
"checks  if  a method of a manifest class is modified and update false positive in the browser"

		
	(criticModel criticsModelContains: anAnnouncement oldMethod)
		ifFalse: [^ self].
	cache replaceAll: (anAnnouncement oldMethod) by: (anAnnouncement newMethod).
	self reapplyThisRule	
! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 2/1/2013 15:02'!
methodRemoved: anAnnouncement

	| classes |
	classes := (rbEnvironment packages gather: [:package | package packageSet packages])
		gather: [:p | p classes].
	
	(classes anySatisfy: [ :cl | anAnnouncement methodClass = cl ]) 
				ifFalse: [ ^ self ].
	

	cache itemRemoved: anAnnouncement methodRemoved! !

!CriticBrowser methodsFor: 'protocol' stamp: 'SimonAllier 2/8/2013 13:24'!
onWindowClosed
	| text |	

	cache cacheChange 
		ifTrue: [	
			text := 'Do you want log all false positive in the Manifests
before closing the Critics Browser ?' .
			(MorphicUIManager new confirm: text)
				ifTrue: [ 
					cache logInManifest ]].
	
! !

!CriticBrowser methodsFor: 'display' stamp: ''!
open

	window := self openWithSpec.
	^ window.! !

!CriticBrowser methodsFor: 'protocol' stamp: ''!
openWithSpec

	window := super openWithSpec.
	^ window.! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 1/23/2013 16:00'!
reapplyAllRules
	
	|  ruleCount total  rule |
	ruleCount := 0.
	rule := rulesModel getRoots first.
	total := rule leaves size.

	 rule leaves do: [ :r |
		ruleCount := ruleCount + 1.
		self setTitle: (String streamContents: [:s | s << 'run rules: ' << r name << ' (' << ruleCount asString << '/' << total asString <<')']).
		self reapplyRule: r ]. 	
	self setTitle: 'Critics Browser'.
	

	 "criticModel updateList."
	 rulesModel updateTree! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/1/2013 14:43'!
reapplyRule: aRule

	|  oldCritics |
	oldCritics := aRule critics.
	aRule resetResult.
	rbEnvironment packages do: [:package |
		package packageSet packages do: [:RPa |
				checker runRules: aRule onPackage: RPa withoutTestCase: removeTestCase]]. 	
	(oldCritics \ (aRule critics)) do: [:each |
		cache removeCritic: each forRule: aRule.
		cache removeFalsePositive: each forRule: aRule.
		cache removeToDo: each forRule: aRule.
		].
	checker rule: aRule. ! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 1/31/2013 14:13'!
reapplyThisRule

	| rule |
	rulesModel selectedItem isNil
		ifTrue: [^ self].
	rule := rulesModel selectedItem. 
	rule leaves do: [:each |	self reapplyRule: each]. 
! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 2/5/2013 11:49'!
registerToAnnouncements
	
	SystemAnnouncer uniqueInstance weak
	"	on: ClassRemoved send: #classRemoved: to: self;"
		on: ClassModifiedClassDefinition send: #classModified: to: self;
	"	on: MethodAdded send: #methodAdded: to: self;"
		on: MethodModified send: #methodModified: to: self;
		on: MethodRemoved send: #methodRemoved: to: self.
		
	
	self window window announcer on: WindowClosed do: [self onWindowClosed]	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 1/31/2013 11:50'!
removeRuleToFalsePositive

	rulesModel selectedItem ifNotNil: [ :rule |
		rule leaves do: [ :r |
			rbEnvironment packages do: [:package |
				 cache removeFalsePositiveRule: r forPackage: package]]].

	
	! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/21/2013 17:03'!
removeTestCase: aBoolean
	removeTestCase :=  aBoolean! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/29/2013 15:27'!
resetButton
	^ resetButton ! !

!CriticBrowser methodsFor: 'private' stamp: 'StephaneDucasse 12/22/2012 19:57'!
resetWorkingConfiguration

	"For now we do not remember what was previously selected."
	CriticWorkingConfiguration reset.! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 5/22/2012 16:00'!
rules: aCompositeRule

	self rulesModel roots: {aCompositeRule}
	
	
! !

!CriticBrowser methodsFor: 'accessing' stamp: ''!
rulesModel

	^ rulesModel! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 15:34'!
setActionLogButtom
	|text|
	
	text := 'Do you want to save all false positive and toDo in the Manifests ?
(this action may generate new manifest classes and make dirty your package)' .
	^ [(MorphicUIManager new confirm: text)
		ifTrue: [ cache logInManifest] ]! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 15:31'!
setActionResetButtom
	|text|
	
	text := 'Do you want to delete the current configuration
 and create a new configuration ?' .
	^ [(MorphicUIManager new confirm: text)
		ifTrue: [ self  delete. 
				SelectPackageBrowser open.] ]! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 15:32'!
setLogButton

	logButton 
		state: false;
		label: 'Save Critics';
		action: self setActionLogButtom ! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 15:31'!
setResetButton

	resetButton 
		state: false;
		label: 'Run new configuration';
		action: self setActionResetButtom.! !

!CriticBrowser methodsFor: 'protocol' stamp: 'Sd 11/30/2012 17:32'!
setTitle: aTitle
	title := aTitle.
	self window updateTitle 
	! !

!CriticBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/24/2012 17:29'!
taskbarIcon

	^ self class icon! !

!CriticBrowser methodsFor: 'protocol' stamp: 'SimonAllier 7/27/2012 11:08'!
title
	^ title! !

!CriticBrowser methodsFor: 'thread' stamp: 'SimonAllier 1/23/2013 16:33'!
updateTree

	thread ifNotNil: [ thread terminate ].
	thread := [ WorldState addDeferredUIMessage: [ 
			criticModel updateList. 
			rulesModel updateTree.]] fork.! !

ComposableModel subclass: #CriticToolbar
	instanceVariableNames: 'ruleHolder criticHolder browseModel falsepositiveModel transformModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticToolbar commentStamp: '<historical>' prior: 0!
I'am a toolbar for the SmallLint Critics


Instance Variables
	browseModel:		<Object>
	criticHolder:		<Object>
	falsepositiveModel:		<Object>
	ruleHolder:		<Object>
	transformModel:		<Object>

browseModel
	- xxxxx

criticHolder
	- xxxxx

falsepositiveModel
	- xxxxx

ruleHolder
	- xxxxx

transformModel
	- xxxxx
!

!CriticToolbar class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:55'!
defaultSpec
<spec>

	^SpecLayout composed
		newRow: [:r |
			r 
				add: #browseModel;
				add: #transformModel;
				add: #falsepositiveModel
			]  height: 25! !

!CriticToolbar methodsFor: 'private' stamp: ''!
browseCritic

	criticHolder contents
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass  browse]
				ifFalse: [elem browse] ] ! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
browseModel

	^ browseModel! !

!CriticToolbar methodsFor: 'protocol' stamp: ''!
critic: aCritic

	criticHolder contents: aCritic! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
falsepositiveModel

	^ falsepositiveModel! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
initialize

	super initialize.

	criticHolder := nil asValueHolder.
	ruleHolder := nil asValueHolder.
	browseModel := self instantiate: ButtonModel.
	transformModel := self instantiate: ButtonModel.
	falsepositiveModel := self instantiate: ButtonModel.

	self setFocusOrder.
	
	self setBrowseModel.
	self setTransformModel.
	self setFalsepositiveModel.

	self registerForChanges.! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 7/24/2012 14:07'!
initializeWidgets! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:55'!
registerForChanges

	criticHolder whenChangedDo: [:contents || boolean |
		boolean := contents notNil.
		browseModel state: (boolean and: [ browseModel enabled ]).
		transformModel state: (boolean and: [ transformModel enabled ]).
		falsepositiveModel state: (boolean and: [ falsepositiveModel enabled ]) ]
! !

!CriticToolbar methodsFor: 'protocol' stamp: ''!
rule: aRule
	
	ruleHolder contents: aRule.
	
	aRule isTransformationRule 
		ifTrue: [transformModel enabled: true]	
		ifFalse: [transformModel enabled: false]
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setBrowseModel
	
	browseModel
		state: false;
		label: 'Browse';
		action: [ self browseCritic ].
	
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setFalsepositiveModel
	
	falsepositiveModel
		state: false;
		label: 'False Positive';
		action: [  ].
	
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: browseModel;
		add: transformModel;
		add: falsepositiveModel.
		! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setTransformModel
	
	transformModel
		state: false;
		label: 'Transform';
		action: [ self transformCritic ].
	
! !

!CriticToolbar methodsFor: 'private' stamp: ''!
transformCritic

	| changeCode rule selection |
	
	rule := ruleHolder contents
		ifNotNil: [:r | r ].
	rule isTransformationRule 
		ifFalse: [^ self].
			
	selection := criticHolder contents
		ifNotNil: [:critic | critic].			
	selection ifNotNil: [	
		changeCode := (rule changes detect: [:ch |
			((ch changeClassName) = (selection methodClass name)) & (ch selector = selection selector)]) source.
	
		selection methodClass compile: changeCode]! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
transformModel

	^ transformModel! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
whenFalsePositiveClickedDo: aBlock

	self falsepositiveModel whenActionPerformedDo: aBlock! !

ComposableModel subclass: #ResetWindow
	instanceVariableNames: 'resetModel currentConfigurationModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!ResetWindow class methodsFor: 'specs' stamp: 'SimonAllier 1/28/2013 10:23'!
defaultSpec
<spec>

	^SpecLayout composed
		newRow: [:r |
			r 
				add: #resetModel;
				add: #currentConfigurationModel
			]  height: 25! !

!ResetWindow class methodsFor: 'specs' stamp: 'SimonAllier 1/28/2013 10:31'!
title
	^ 'Critic Browser' ! !

!ResetWindow methodsFor: 'accessing' stamp: 'SimonAllier 1/28/2013 10:24'!
currentConfigurationModel
	^ currentConfigurationModel! !

!ResetWindow methodsFor: 'initialization' stamp: 'SimonAllier 1/28/2013 11:35'!
initialExtent

	^   450@30! !

!ResetWindow methodsFor: 'initialization' stamp: 'SimonAllier 1/28/2013 10:22'!
initializeWidgets

	self instantiateModels: #(
		resetModel ButtonModel
		currentConfigurationModel ButtonModel 
		 ).

	self setFocusOrder.

	self setResetModel. 
	self setCurrentConfigurationModel. 
	! !

!ResetWindow methodsFor: 'accessing' stamp: 'SimonAllier 1/28/2013 10:24'!
resetModel
	^ resetModel! !

!ResetWindow methodsFor: 'initialization' stamp: 'SimonAllier 1/28/2013 10:31'!
setCurrentConfigurationModel
	currentConfigurationModel  
		state: false;
		label: 'Uses Current Configuration';
		action: [CriticBrowser openOnWorkspace: CriticWorkingConfiguration current. self delete]! !

!ResetWindow methodsFor: 'initialization' stamp: 'SimonAllier 1/28/2013 10:23'!
setFocusOrder

	self focusOrder
		add: resetModel;
		add: currentConfigurationModel! !

!ResetWindow methodsFor: 'initialization' stamp: 'SimonAllier 1/28/2013 10:32'!
setResetModel
	resetModel 
		state: false;
		label: 'Reset Current Configurartion';
		action: [ SelectPackageBrowser open. self delete]! !

ComposableModel subclass: #SelectBrowser
	instanceVariableNames: 'toSelectModel selectedModel addButtonModel addAllButtonModel removeButtonModel removeAllButtonModel nextButtonModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectBrowser commentStamp: '<historical>' prior: 0!
A simple selection browser.!

!SelectBrowser class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:56'!
defaultSpec

		<spec>
	
	^ SpecLayout composed
		newColumn: [:c |
			c
			newRow: [:r |
				r 
					add: #toSelectModel;
					addSplitter;
					add:  #selectedModel];
			newRow: [:r |
				r 
					add:#addButtonModel;
					add:#addAllButtonModel;
					add:#removeButtonModel;
					add:#removeAllButtonModel;
					add: #nextButtonModel ] height: 25]	! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
addAllButtonModel
	^ addAllButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
addButtonModel
	^ addButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: 'SimonAllier 2/1/2013 14:31'!
initialExtent

	^   450@360! !

!SelectBrowser methodsFor: 'initialization' stamp: 'SimonAllier 1/28/2013 10:36'!
initializeWidgets

	self instantiateModels: #(
		addButtonModel ButtonModel
		addAllButtonModel ButtonModel 
		removeButtonModel ButtonModel
		removeAllButtonModel ButtonModel
		nextButtonModel ButtonModel ).
		
	self setFocusOrder.

	self setAddButtonModel. 
	self setAddAllButtonModel. 
	self setRemoveButtonModel. 
	self setRemoveAllButtonModel. 
	self setNextButtonModel. ! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
items: aCollection
	
	toSelectModel items: (self sort: aCollection)
! !

!SelectBrowser methodsFor: 'private' stamp: ''!
nextAction
	self subclassResponsibility
! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
nextButtonModel
	^ nextButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
removeAllButtonModel
	^ removeAllButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
removeButtonModel
	^ removeButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
selectedModel
	^ selectedModel! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setAddAllButtonModel
	
	addAllButtonModel
		state: false;
		label: 'Add All';
		action: [ self  addAllItems].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:37'!
setAddButtonModel
	
	addButtonModel
		state: false;
		label: 'Add';
		action: [ self addItems ].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: addButtonModel;
		add: addAllButtonModel;
		add: removeButtonModel;
		add: removeAllButtonModel.
		! !

!SelectBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:37'!
setNextButtonModel
	
	nextButtonModel
		state: false;
		label: 'Next';
		action: [ self  nextAction ].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:37'!
setRemoveAllButtonModel
	
	removeAllButtonModel
		state: false;
		label: 'Remove All';
		action: [ self  removeAllItems ].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setRemoveButtonModel
	
	removeButtonModel
		state: false;
		label: 'Remove';
		action: [ self removeItems ].
	
! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
toSelectModel
	^ toSelectModel! !

SelectBrowser subclass: #SelectPackageBrowser
	instanceVariableNames: 'addTestCaseClassesModel removeTestPackageModel testPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectPackageBrowser commentStamp: '<historical>' prior: 0!
To select packages.!

!SelectPackageBrowser class methodsFor: 'specs' stamp: 'SimonAllier 1/28/2013 11:12'!
defaultSpec

		<spec>
	
	^ SpecLayout composed
		newColumn: [:c |
			c
			newRow: [:r |
				r 
					add: #toSelectModel; 
					addSplitter;
					add:  #selectedModel];
			newRow: [:r |
				r
					add: # removeTestPackageModel; 
					add: #addTestCaseClasses]  height: 25;
			newRow: [:r |
				r 
					add:#addButtonModel;
					add:#addAllButtonModel;
					add:#removeButtonModel;
					add:#removeAllButtonModel;
					add: #nextButtonModel ] height: 25]	! !

!SelectPackageBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 3/29/2012 15:46'!
open
	
	self new items: MCWorkingCopy allManagers;
		openWithSpec ! !

!SelectPackageBrowser class methodsFor: 'specs' stamp: ''!
title
	^ 'Select packages'! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:16'!
addAllItems

	| tmp |
	tmp := self sort: (selectedModel listItems asOrderedCollection addAll: (toSelectModel listItems);yourself ).
	selectedModel  items: tmp.
	toSelectModel  items: {}.
	toSelectModel updateList.
	selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:16'!
addItems
	
	toSelectModel selectedItems
		ifNotNil: [ :items |  
			selectedModel items: (self sort:(selectedModel listItems asOrderedCollection addAll: items; yourself) ).
			toSelectModel items: (self sort:(toSelectModel listItems asOrderedCollection removeAll: items; yourself) ) ].
		toSelectModel updateList.
		selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/28/2013 10:49'!
addTestCaseClasses
	^ addTestCaseClassesModel
! !

!SelectPackageBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 1/28/2013 11:11'!
initialize

	| wrappingBlock |
	super initialize.	
	toSelectModel := self instantiate: ListComposableModel.
	selectedModel := self instantiate: ListComposableModel.
	selectedModel beMultipleSelection.
	toSelectModel beMultipleSelection.
	
	testPackage := OrderedCollection new.
	
	wrappingBlock := [:package |
		package packageName].
	
	toSelectModel displayBlock: wrappingBlock.
	selectedModel displayBlock: wrappingBlock.! !

!SelectPackageBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 1/28/2013 11:14'!
initializeWidgets
	super initializeWidgets.
	
	
	self instantiateModels: #(
		addTestCaseClassesModel CheckBoxModel
		removeTestPackageModel ButtonModel).
	
	self setRemoveTestPackageModel.		
	addTestCaseClassesModel label: 'remove all TestCase Classes'.
	addTestCaseClassesModel state: true.! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 1/31/2013 13:20'!
nextAction

	| env package|	
		
	package := selectedModel listItems.
	env := RBPackageEnvironment new packages: package.
	SelectRuleBrowser openWithEnvironment: env removeTestCase: self addTestCaseClasses state.
	self delete
	
		
! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:17'!
removeAllItems

	| tmp |
	tmp := self sort: (toSelectModel listItems asOrderedCollection addAll: (selectedModel listItems);yourself ).
	toSelectModel   items: tmp.
	selectedModel items: {}.
	toSelectModel updateList.
	selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:18'!
removeItems
	
	selectedModel selectedItems
		ifNotNil: [:items | 
			toSelectModel items: ( self sort: (toSelectModel listItems asOrderedCollection addAll: items; yourself)).
			selectedModel items: (self sort: (selectedModel listItems asOrderedCollection removeAll: items; yourself)).
			].
		toSelectModel updateList.
		selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 1/28/2013 14:35'!
removeTestPackage

	| matchText  |
	testPackage isEmpty
		ifTrue: [
			removeTestPackageModel label: 'Remove All Packages Tests'.
			matchText := '*Test*'.
			testPackage :=MCWorkingCopy allManagers select: [:package | matchText match:  package packageName].
		
			selectedModel items: (self sort:(selectedModel listItems \ testPackage)).
			toSelectModel items: (self sort:(toSelectModel  listItems \ testPackage))
		]
		ifFalse: [
			removeTestPackageModel label: 'Add All Packages Tests'.		
			toSelectModel items: (self sort:(toSelectModel listItems asOrderedCollection addAll: testPackage; yourself)).
			testPackage := OrderedCollection new]. 
	
	
		toSelectModel updateList.
		selectedModel updateList.  	! !

!SelectPackageBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 1/28/2013 11:11'!
removeTestPackageModel

	^ removeTestPackageModel
	
	! !

!SelectPackageBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 1/28/2013 10:52'!
setRemoveTestPackageModel

	removeTestPackageModel
		state: false;
		label: 'Remove All Packages Tests';
		action: [ self  removeTestPackage ].
	! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 5/21/2012 16:09'!
sort: aCollection
	
	^ aCollection asOrderedCollection sort: [:e1 :e2 | (e1 asString) < (e2 asString)].! !

SelectBrowser subclass: #SelectRuleBrowser
	instanceVariableNames: 'selectRule environment removeTestCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectRuleBrowser commentStamp: '<historical>' prior: 0!
To select rules.!

!SelectRuleBrowser class methodsFor: 'specs' stamp: 'SimonAllier 1/28/2013 10:37'!
defaultSpec

		<spec>
	
	^ SpecLayout composed
		newColumn: [:c |
			c
			newRow: [:r |
				r 
					add: #toSelectModel; 
					addSplitter;
					add:  #selectedModel];
			newRow: [:r |
				r 
					add:#addButtonModel;
					add:#addAllButtonModel;
					add:#removeButtonModel;
					add:#removeAllButtonModel;
					add: #nextButtonModel ] height: 25]	! !

!SelectRuleBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 1/29/2013 13:42'!
openWithEnvironment: aEnv removeTestCase: aBooelan
	
	self new items: (RBCompositeLintRule allGoodRules rules);
		environment: aEnv;
		removeTestCase: aBooelan;
		openWithSpec;
		updateTree . ! !

!SelectRuleBrowser class methodsFor: 'specs' stamp: ''!
title
	^ 'Select rules'! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'Sd 11/30/2012 17:38'!
addAllItems
	
	toSelectModel getRoots do: [:item |  
		selectRule addAll: (item leaves) ].
	self updateTree.  	  ! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'Sd 11/30/2012 17:38'!
addItems
	
	toSelectModel selectedItem
		ifNotNil: [ :item |  
			selectRule addAll: (item leaves) ].
	self updateTree   	  ! !

!SelectRuleBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/24/2012 17:11'!
defaultRulesRootName

	^ 'Selected Rules'! !

!SelectRuleBrowser methodsFor: 'accessing' stamp: ''!
environment: aEnv
	environment := aEnv! !

!SelectRuleBrowser methodsFor: 'initialize-release' stamp: 'Sd 11/30/2012 17:39'!
initialize

	| wrappingBlock childrenBlockS childrenBlockTS |
	super initialize.
	
	toSelectModel := self instantiate: TreeModel.
	selectedModel := self instantiate: TreeModel.
	selectRule := Set new.
		
	 childrenBlockS := [:rule | 
		rule isComposite 
			ifTrue: [rule rules select: [ :r |
					(selectRule anySatisfy:  [:sr | sr = r]) or: [r isComposite] ]]
			 ifFalse: [{}]]. 
	 childrenBlockTS := [ :rule | 
		rule isComposite 
			ifTrue: [rule rules select: [:r |
					(selectRule anySatisfy: [:sr | sr = r]) not or: [r isComposite]]]
			 ifFalse: [{}] ]. 

	toSelectModel childrenBlock: childrenBlockTS.
	selectedModel childrenBlock: childrenBlockS.
	wrappingBlock := [ :rule | rule name ].
	
	toSelectModel displayBlock: wrappingBlock.
	selectedModel displayBlock: wrappingBlock.! !

!SelectRuleBrowser methodsFor: 'accessing' stamp: 'SimonAllier 5/22/2012 10:45'!
items: aCollection
	
	toSelectModel roots: aCollection.
	selectedModel roots: aCollection
! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'SimonAllier 1/31/2013 14:17'!
nextAction
	| rules rbRule |
	self delete.

	rules := selectedModel getRoots.
	rules
		do: [ :each | 
			each leaves
				do: [ :leave | 
					(selectRule anySatisfy: [ :r | r = leave ])
						ifFalse: [ each removeRule: leave ] ] ].
	rules := rules reject: [ :each | each rules isEmpty ].
	rbRule := RBCompositeLintRule new
		name: self defaultRulesRootName;
		rules: rules.
			
	CriticWorkingConfiguration current
		rule: rbRule;
		environment: environment;
		removeTestCase: removeTestCase.
	CriticBrowser openOnWorkspace: CriticWorkingConfiguration current! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'Sd 11/30/2012 17:39'!
removeAllItems
	
	selectedModel getRoots do: [ :item |  
		selectRule removeAllFoundIn: (item leaves)].
	self updateTree 	  ! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'StephaneDucasse 11/21/2012 18:24'!
removeItems
	
	selectedModel selectedItem
		ifNotNil: [ :item |  
			selectRule removeAllFoundIn: (item leaves) ].
	self updateTree  	  ! !

!SelectRuleBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/29/2013 13:41'!
removeTestCase: aBoolean
	removeTestCase := aBoolean! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'StephaneDucasse 11/21/2012 18:24'!
updateTree

	toSelectModel updateTree.
	selectedModel updateTree.  	  ! !

ComposableModel subclass: #SingleRuleCriticBrowser
	instanceVariableNames: 'rule criticsModel toolbarModel sourceCodeModel textInputFieldModel cache thread'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

SingleRuleCriticBrowser class
	instanceVariableNames: 'icons'!

!SingleRuleCriticBrowser commentStamp: '<historical>' prior: 0!
I am a browser for the SmallLint Critics of a rule.!

SingleRuleCriticBrowser class
	instanceVariableNames: 'icons'!

!SingleRuleCriticBrowser class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:53'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		newColumn: [:c |
			c 
				add: #criticsModel;
				add: #toolbarModel height: 25;
				addSplitter;
				add: #textModel ]! !

!SingleRuleCriticBrowser class methodsFor: 'icons' stamp: 'StephaneDucasse 11/21/2012 18:11'!
exclamationIcon 

	^  icons
			at: #'exclamationIcon'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self  exclamationIconContents readStream) ].
! !

!SingleRuleCriticBrowser class methodsFor: 'icons' stamp: 'StephaneDucasse 11/21/2012 18:11'!
exclamationIconContents
	"Private - Method generated"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJPSURBVDjLpZPLS5RhFMYfv9QJ
lelTQZwRb2OKlKuINuHGLlBEBEOLxAu46oL0F0QQFdWizUCrWnjBaDHgThCMoiKkhUONTqmj
mDp2GZ0UnWbmfc/ztrC+GbM2dXbv4ZzfeQ7vefKMMfifyP89IbevNNCYdkN2kawkCZKfSPZT
OGTf6Y/m1uflKlC3LvsNTWArr9BT2LAf+W73dn5jHclIBFZyfYWU3or7T4K7AJmbl/yG7EtX
1BQXNTVCYgtgbAEAYHlqYHlrsTEVQWr63RZFuqsfDAcdQPrGRR/JF5nKGm9xUxMyr0YBAEXX
HgIANq/3ADQobD2J9fAkNiMTMSFb9z8ambMAQER3JC1XttkYGGZXoyZEGyTHRuBuPgBTUu7V
SnUAgAUAWutOV2MjZGkehgYUA6O5A0AlkAyRnotiX3MLlFKduYCqAtuGXpyH0XQmOj+TIURt
51OzURTYZdBKV2UBSsOIcRp/TVTT4ewK6idECAihtUKOArWcjq/B8tQ6UkUR31+OYXP4sTOd
isivrkMyHodWejlXwcC38Fvs8dY5xaIId89VlJy7ACpCNCFCuOp8+BJ6A631gANQSg1mVmOx
xGQYRW2nHMha4B5WA3chsv22T5/B13AIicWZmNZ6cMchTXUe81Okzz54pLi0uQWp+TmkZqMw
xsBV74Or3od4OISPr0e3SHa3PX0f3HXKofNH/UIG9pZ5PeUth+CyS2EMkEqs4fPEOBJLsysk
e48/+xD8oxcAYPzs4QaS7RR2kbLTTOTQieczfzfTv8QPldGvTGoF6/8AAAAASUVORK5CYII='! !

!SingleRuleCriticBrowser class methodsFor: 'initialization' stamp: 'StephaneDucasse 11/21/2012 18:11'!
initialize
	
	icons := IdentityDictionary new! !

!SingleRuleCriticBrowser class methodsFor: 'specs' stamp: ''!
title

	^ 'Critic Browser'! !

!SingleRuleCriticBrowser class methodsFor: 'icons' stamp: 'StephaneDucasse 11/21/2012 18:13'!
wrenchOrangeIcon

	^  icons
			at: #'wrenchOrangeIcon'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self  wrenchOrangeIconContents readStream) ].
! !

!SingleRuleCriticBrowser class methodsFor: 'icons' stamp: 'StephaneDucasse 11/21/2012 18:13'!
wrenchOrangeIconContents
	"Private - Method generated"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAHaSURBVDjLlZO7a1NRHMfzfzhI
KQ5OHR1ddRRBLA6lg4iTd5PSas37YR56Y2JiHgg21uoFxSatCVFjbl5iNBBiMmUJgWwZhCB4
pR9/V4QKfSQdDufF5/v7nu85xwJYprV0Oq0kk8luIpEw4vG48f/eVDiVSikCTobDIePxmGg0
yokEBO4OBgNGoxH5fJ5wOHwygVgsZpjVW60WqqqWzbVgMIjf78fn8xlTBcTy736/T7VaJRQK
fQoEArqmafR6Pdxu9/ECkUjkglje63Q6NBoNisUihUKBcrlMpVLB6XR2D4df3VQnmRstsWzU
63WazSZmX6vV0HWdUqmEw+GY2Gw25SC8dV1l1wrZNX5s3qLdbpPL5fB6vXumZalq2O32rtVq
VQ6GuGnCd+HbFnx9AZrC+MkSHo/np8vlmj/M7f4ks6yysyawgB8fwPv70HgKG8v8cp/7fFRO
/+AllewqNJ/DhyBsi9A7J1QTkF4E69mXRws8u6ayvSJwRqoG4K2Md+ygxyF5FdbPaMfdlIXU
ZfiyAUWx/OY25O4JHBP4CtyZ16a9EwuRi1CXs+5K1ew6lB9DXERX517P8tEsPDzfNIP6C5Ye
QewSrJyeCd4P0bnwXYISy3MCn5oZNtsf3pH46e7XBJcAAAAASUVORK5CYII='! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/24/2013 11:30'!
addAllCriticsToFalsePositive

	"(criticsModel listItems 
		groupedBy: [:each | checker manifestBuilderOf: each]) 
			keysAndValuesDo: [:key :value | 
					self addAllCriticToFalsePositive: value on: key].
	self updateList
			"
	criticsModel listItems do: [:item |
		cache addFalsePositive: item forRule: rule].! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/25/2013 14:32'!
addClassToFalsePositive
	| class |
	
	criticsModel selectedItems ifNotNil: [ :items |
		items do: [ :critic |
			class := critic isCompiledMethod 
				ifTrue: [  critic methodClass]
				ifFalse: [critic].
			cache addFalsePositiveClass: class.
			]]
	
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/23/2013 16:32'!
addCriticToFalsePositive
	
	criticsModel selectedItems
		ifNotNil: [:items | items do: [:item |
			cache addFalsePositive: item forRule: rule	]].
	
	"self updateList"
	
	"criticsModel selectedItems
		ifNotNil: [:items | 
			(items groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:key :value |
					self addAllCriticToFalsePositive: value on: key]].
		self updateList"! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/23/2013 16:32'!
addCriticToToDo

	criticsModel selectedItems
		ifNotNil: [:items | items do: [:item |
			cache addToDo: item forRule: rule	]].
		
		"self updateList"

"	|  ruleId versionId |
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	criticsModel selectedItems 
		ifNotNil: [:items | 
			(items groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:manifestBuilder :critis |
					(manifestBuilder hasToDoOf: ruleId version: versionId) 
						ifFalse: [manifestBuilder installToDoOf: ruleId version: versionId].
	 				manifestBuilder addAllToDo: critis of: ruleId version: versionId]].
	
	self updateList
	 "! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/25/2013 15:05'!
addCriticWithCommentToFalsePositive
	self flag: ' que faire?'
	"toDo "
"	| aCritic |
	aCritic := criticsModel selectedItem.
	aCritic isNil 
		ifTrue: [ ^ self ]. 
	self addCriticToFalsePositive: aCritic.
	self  updateList.
	CommentFalsePositiveWindow openOnCritic: aCritic onRule: rule. 
"
	
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/24/2013 11:31'!
addCriticWithCommentToToDo
self flag: ' que faire ?'
"toDo "

"	| aCritic |
	aCritic := criticsModel selectedItem.
	aCritic isNil 
		ifTrue: [^ self]. 
	self addCriticToToDo.
	CommentToDoWindow openOnCritic: aCritic onRule: rule. 
	"
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/23/2013 11:16'!
addRuleToFalsePositive

	"todo"

	"| manifestBuilder |
	criticsModel selectedItems ifNotNil: [ :criticss |
		criticss do: [ :critic |
		manifestBuilder := checker manifestBuilderOf: critic. 
		manifestBuilder addRejectRule: rule class uniqueIdentifierName]].
	self updateList"
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:42'!
browseCritic

	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass browse ]
				ifFalse: [ elem browse ] ] ! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/23/2013 11:22'!
cache:  acache 
	cache := acache! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: ''!
criticsModel

	^ criticsModel! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:42'!
criticsModelContains: aCritic

	^ criticsModel listItems anySatisfy: [:each |
		aCritic isCompiledMethod
			ifTrue: [
				 each isCompiledMethod 
					ifTrue: [ each methodClass = aCritic methodClass and: [ each selector = aCritic selector ]]
					ifFalse: [false]
				 ]
			ifFalse: [each = aCritic ] ]! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'CamilloBruni 2/22/2013 23:14'!
criticsOf: aRule
	cache ifNil: [^ {}].
	criticsModel items: ((cache criticsOf: aRule)
				sorted: [ :a :b| 
					a methodClass = b methodClass
						ifTrue: [ a selector <= b selector ]
						ifFalse: [ a methodClass name <= b methodClass name ]]).! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'SimonAllier 8/28/2012 10:55'!
defaultColor

	^ Color red! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: ''!
falsePositiveColor

	^ Color darkGray! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/1/2013 16:26'!
formatCritic: aCritic
	
	^  String streamContents: [:s |
		aCritic isCompiledMethod
			ifTrue: [ 
				s << aCritic methodClass name << '>>#' << aCritic selector  << ' (' << aCritic methodClass theNonMetaClass category << ')' ]
			ifFalse: [
				s << aCritic name << ' (' << aCritic category << ')' ]].
"	result := String streamContents: 
					[:s | s   
						<< result 
						<< ' (' 
						<< (checker manifestBuilderOf: aCritic) packageName  todo ' fgfg'
						<< ')' ]."! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'SimonAllier 1/23/2013 11:49'!
iconFor: anItem
	
	^  (cache isFalsePositive: anItem forRule: rule) 
			ifFalse: [(cache isToDo: anItem forRule: rule)
				ifTrue: [ self class wrenchOrangeIcon ]
				ifFalse: [ self class exclamationIcon ] ]! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 11/24/2012 17:16'!
implementorsOfCritic

	criticsModel selectedItem
		ifNotNil: [ :item | 
			item isBehavior 
				ifTrue: [ item theNonMetaClass  browse]
				ifFalse: [ AbstractTool new browseMessagesFrom:  item selector ]] ! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'StephaneDucasse 11/21/2012 17:50'!
initializeActionToPerformOnTextModel
	| selectedItem |
	
	sourceCodeModel acceptBlock:  [:text | 	
		selectedItem := criticsModel selectedItem.
		((selectedItem isCompiledMethod) and: [rule isTransformationRule not])
			ifTrue: [ selectedItem methodClass compile: text ] 
			ifFalse: [ Compiler evaluate:  text ]]
	
! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 1/23/2013 11:26'!
initializeDisplayCritic: aCritic forRule: aRule
	
	| criticRepresentation | 
	criticRepresentation := (self formatCritic: aCritic) asMorph.
	^ (cache isFalsePositive: aCritic forRule: aRule) 
			ifTrue: [ criticRepresentation color: self falsePositiveColor ]
			ifFalse: [ (cache isToDo: aCritic forRule: aRule)
						ifTrue: [ criticRepresentation color: self toDoColor ]
						ifFalse: [ criticRepresentation color: self defaultColor ]]! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:53'!
initializePresenter

	self whenSelectedItemChangesOnListModel.
	

! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 16:10'!
initializeTextInputFieldModel
	|critics|
	
	
	textInputFieldModel 
		autoAccept: true;
		ghostText: 'Search field';
		text: ' ';
		removeEntryCompletion.
	
	textInputFieldModel acceptBlock: [: text | |matchText|
		critics :=cache criticsOf: rule.
		matchText := '*', text, '*'.
		criticsModel items: (text isEmpty 
			ifTrue: [critics]
			ifFalse: [ critics select: [:critic |
				matchText match: (self formatCritic: critic)]]).
		criticsModel updateList]
! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 1/25/2013 16:25'!
initializeToolBar
	
	self toolbarModel whenFalsePositiveClickedDo: [ self addCriticToFalsePositive ].

! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 16:06'!
initializeWidgets

	self instantiateModels: #(
		criticsModel IconListModel
		sourceCodeModel TextModel 
		toolbarModel CriticToolbar
		textInputFieldModel TextInputFieldModel ).

	criticsModel beMultipleSelection.
		
	self initializeTextInputFieldModel.
	self initializeToolBar.
	self initializeActionToPerformOnTextModel.

	criticsModel displayBlock: [:selec |
		self 
			initializeDisplayCritic: selec forRule: rule]. 
	
	criticsModel menu: [:a :b | self menu: a shifted: b ].
	criticsModel icons: [:item | self iconFor: item ].
	
	self focusOrder
		add: criticsModel;
		add: toolbarModel;
		add: sourceCodeModel.
! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 2/1/2013 16:33'!
menu: aMenu shifted: aBoolean

	aMenu
		add: 'Browse' translated
			target: self
			selector: #browseCritic;
		add: 'Senders' translated
			target: self
			selector: #sendersOfCritic;
		add: 'Implementors' translated
			target: self
			selector: #implementorsOfCritic;
		addLine;
		add: 'Mark selected critic as false Positive' translated
			target: self
			selector: #addCriticToFalsePositive;
		"add: 'Mark selected critic as false Positive with a comment' translated
			target: self
			selector: #addCriticWithCommentToFalsePositive;"
		add: 'Unmark selected critic as false Positive' translated 
			target: self
			selector: #removeCriticToFalsePositive;
		add: 'Mark all critics as false Positive' translated
			target: self
			selector: #addAllCriticsToFalsePositive;
		add: 'Unmark all critics as false Positive' translated
			target: self
			selector: #removeAllCriticsToFalsePositive;
		addLine;
		add: 'Mark selected critic as TODO' translated
			target: self
			selector: #addCriticToToDo;
		"add: 'Mark selected critic as TODO with comment' translated
			target: self
			selector: # addCriticWithCommentToToDo;"
		add: 'Unmark selected critic as TODO' translated
			target: self
			selector: #removeCriticToToDo;
		addLine;
		add: 'Mark selected class as false Positive' translated
			target: self
			selector: #addClassToFalsePositive;
		add: 'Unmark selected class as false Positive' translated
			target: self
			selector: #removeClassToFalsePositive;
		addLine;
		add: 'Ban this rule for the selected package' translated
			target: self
			selector: #addRuleToFalsePositive;
		add: 'Unban this rule for the selected package' translated
			target: self
			selector: #removeRuleToFalsePositive.
	^ aMenu! !

!SingleRuleCriticBrowser methodsFor: 'message handling' stamp: 'SimonAllier 5/21/2012 14:28'!
perform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ (self respondsTo: selector) ifTrue: [self perform: selector] ifFalse: [otherTarget perform: selector]! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/23/2013 16:32'!
removeAllCriticsToFalsePositive

	criticsModel listItems
		 do: [:item |
			cache removeFalsePositive: item forRule: rule	].

		"self updateList"
	
	"(criticsModel  listItems groupedBy: [:each | checker manifestBuilderOf: each]) 
		keysAndValuesDo: [:key :value |
			self removeAllCriticToFalsePositive: value on: key].
	self updateList"
			! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/25/2013 14:33'!
removeClassToFalsePositive
		| class |
	
	criticsModel selectedItems ifNotNil: [ :items |
		items do: [ :critic |
			class := critic isCompiledMethod 
				ifTrue: [  critic methodClass]
				ifFalse: [critic].
			cache removeFalsePositiveClass: class.
			]]
	
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/23/2013 16:32'!
removeCriticToFalsePositive
	
	criticsModel selectedItems
		ifNotNil: [:items | items do: [:item |
			cache removeFalsePositive: item forRule: rule	]].
	
		"self updateList"
	
	"criticsModel selectedItems
		ifNotNil: [:criticss | 
			(criticss groupedBy: [ :each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [ :key :value |
					self removeAllCriticToFalsePositive: value on: key]].
		self updateList"! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/23/2013 16:32'!
removeCriticToToDo

		criticsModel selectedItems
		ifNotNil: [:items | items do: [:item |
			cache removeToDo: item forRule: rule	]].
	
		"self updateList"

"	|  ruleId versionId |
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	criticsModel selectedItems 
		ifNotNil: [:criticss | 
			(criticss groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:manifestBuilder :critis |
					(manifestBuilder hasToDoOf: ruleId version: versionId) 
						ifTrue: [ manifestBuilder removeAllToDo: critis of: ruleId version: versionId]].
	 			].
	
	self updateList"
	 ! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 1/23/2013 11:18'!
removeRuleToFalsePositive

	"toDo "

	"| manifestBuilder |
	criticsModel selectedItems ifNotNil: [ :criticss |
		criticss do: [ :critic |
			manifestBuilder := checker manifestBuilderOf: critic.
			manifestBuilder removeRejectRule: rule class uniqueIdentifierName]].
	self  updateList
	"! !

!SingleRuleCriticBrowser methodsFor: 'protocol' stamp: ''!
resetSelection

	self criticsModel resetSelection! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 1/23/2013 16:10'!
rule: aRule

	rule := aRule.
	(rule isNil or: [rule isComposite ]) 
		ifTrue: [ ^ self].	
			
	self criticsOf:   aRule.
	toolbarModel rule: rule.! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: ''!
selectionIntervalFor: aString
	^ rule result selectionIntervalFor: aString! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 11/21/2012 17:55'!
sendersOfCritic

	| abstractTool |
	abstractTool := AbstractTool new. 	
	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ abstractTool browseClassRefsOf: elem]
				ifFalse: [abstractTool browseSendersOfMessagesFrom: elem selector] ] ! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:48'!
setTextModelForClass: cl

	| interval |
	sourceCodeModel aboutToStyle: true.
	sourceCodeModel text: cl definition.
	sourceCodeModel behavior: nil .
	
	interval := (self selectionIntervalFor: cl definition).
	interval ifNotNil: [sourceCodeModel setSelection: interval].
	
	
					! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:49'!
setTextModelForMethod: selection

	| interval |
	sourceCodeModel aboutToStyle: true.
	sourceCodeModel text: selection sourceCode.
	sourceCodeModel behavior: selection methodClass.
	interval := self selectionIntervalFor: selection sourceCode.
	interval ifNotNil: [sourceCodeModel setSelection: interval].
	
	
					! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:49'!
setTextModelForNil

	| text |
	text := rule longDescription isEmpty 
		ifTrue: [rule name]
		ifFalse:[rule longDescription]. 
	sourceCodeModel aboutToStyle: false.
	sourceCodeModel text: text.
	sourceCodeModel behavior: nil.
	toolbarModel critic: nil 
	
	
					! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/1/2013 16:31'!
setTextModelForTransformationRule: selection
	
	| textDiff change |
	rule result.
	change := rule changes detect: [:ch |
		((ch changeClassName) = (selection methodClass theNonMetaClass name)) & (ch selector = selection selector)].
	textDiff := (TextDiffBuilder
		from: (selection sourceCode)
		to:  (change source) inClass: selection methodClass) buildDisplayPatch.
	
	sourceCodeModel behavior: nil.
	sourceCodeModel text: textDiff.
	sourceCodeModel aboutToStyle: false.

									
					! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 3/27/2012 17:18'!
textInputFieldModel
	^ textInputFieldModel! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: ''!
textModel

	^ sourceCodeModel! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'SimonAllier 8/28/2012 10:38'!
toDoColor

	^ Color orange! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: ''!
toolbarModel

	^ toolbarModel! !

!SingleRuleCriticBrowser methodsFor: 'thread' stamp: 'SimonAllier 1/23/2013 16:47'!
updateList
self criticsOf: rule.
	thread ifNotNil: [ thread terminate ].
	thread := [ WorldState addDeferredUIMessage: [ 
			
			criticsModel updateList ]] fork.! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:48'!
whenSelectedItemChangesOnListModel

	criticsModel whenSelectedItemChanged: [:selection |
		rule isNil ifFalse: [
		(selection
			ifNil: [self setTextModelForNil]
			ifNotNil: [
				toolbarModel critic: selection.
				rule isTransformationRule 
					ifTrue: [self setTextModelForTransformationRule: selection]
					ifFalse: [				
						(rule result isSelectorEnvironment or: [rule result isMultiEnvironment])
							ifTrue: [  self setTextModelForMethod: selection]
							ifFalse:  [ self setTextModelForClass: selection]]
				])]]! !

!RBMultiEnvironment methodsFor: '*Manifest-CriticBrowser' stamp: 'SimonAllier 3/30/2012 11:43'!
isMultiEnvironment
	^ true! !

!RBMultiEnvironment methodsFor: '*Manifest-CriticBrowser' stamp: 'StephaneDucasse 11/21/2012 18:25'!
removeClass: aClass
	environmentDictionaries keys do: [ :key |
		(environmentDictionaries at: key) removeClass: aClass ]! !

Object subclass: #CriticWorkingConfiguration
	instanceVariableNames: 'rule environment removeTestCase logInManifest'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticWorkingConfiguration commentStamp: '<historical>' prior: 0!
A CriticWorkspace holds the current worspace for the CriticBrowser.

It's composed of the set of rules to check (as a composite rule) and the environment to work in.!

!CriticWorkingConfiguration class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/24/2012 18:05'!
current

	^ Current ifNil: [ Current  := self basicNew initialize ].! !

!CriticWorkingConfiguration class methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:11'!
exists

	^ Current notNil! !

!CriticWorkingConfiguration class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/24/2012 18:05'!
new

	^ self shouldNotImplement! !

!CriticWorkingConfiguration class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/24/2012 18:05'!
reset

	Current := nil! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:04'!
environment
	^ environment! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:04'!
environment: anObject
	environment := anObject! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'SimonAllier 1/25/2013 17:03'!
logInManifest
	
	^ logInManifest! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'SimonAllier 1/25/2013 17:03'!
logInManifest: anObject
	
	logInManifest := anObject! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'SimonAllier 1/21/2013 17:02'!
removeTestCase
 ^ removeTestCase! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'SimonAllier 1/21/2013 17:02'!
removeTestCase: aBoolean
 removeTestCase := aBoolean! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:04'!
rule
	^ rule! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:04'!
rule: anObject
	rule := anObject! !

Object subclass: #CriticsCache
	instanceVariableNames: 'critics toDos falsePositives checker browser falsePositiveRules falsePositiveClasses packages change'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticsCache commentStamp: '<historical>' prior: 0!
I am a cache for the critics and false positives critics

Instance Variables
	browser:		<Object>
	checker:		<Object>
	critics:		<Object>
	falsePositiveClasses:		<Object>
	falsePositiveRules:		<Object>
	falsePositives:		<Object>
	packages:		<Object>
	toDos:		<Object>

browser
	- xxxxx

checker
	- xxxxx

critics
	- xxxxx

falsePositiveClasses
	- xxxxx

falsePositiveRules
	- xxxxx

falsePositives
	- xxxxx

packages
	- xxxxx

toDos
	- xxxxx
!

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 1/25/2013 14:51'!
addAllCriticToFalsePositive: aCollectionOfCritic forRule: aRule on: aManifestBuilder

	| ruleId versionId  criticss |
	
	criticss := aCollectionOfCritic reject: [:c |
		 falsePositiveClasses includes: (c isCompiledMethod 
			ifTrue: [c methodClass theNonMetaClass] 
			ifFalse:[c])].
	
	ruleId :=  aRule class uniqueIdentifierName.
	versionId :=   aRule class identifierMinorVersionNumber.
	(aManifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
		ifFalse: [aManifestBuilder installFalsePositiveOf: ruleId version: versionId].		
	 aManifestBuilder addAllFalsePositive: criticss of: ruleId version: versionId.

	! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 1/25/2013 13:41'!
addAllCriticToToDo: aCollectionOfCritic forRule: aRule on: aManifestBuilder

	| ruleId versionId  |
	
	ruleId :=  aRule class uniqueIdentifierName.
	versionId :=   aRule class identifierMinorVersionNumber.
	(aManifestBuilder hasToDoOf: ruleId version: versionId) 
		ifFalse: [aManifestBuilder installToDoOf: ruleId version: versionId].		
	 aManifestBuilder addAllToDo: aCollectionOfCritic of: ruleId version: versionId.

	! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:15'!
addCritic: aCritic forRule: aRule

	(critics includesKey: aRule) 
		ifFalse: [critics at:aRule	put: IdentitySet new].
			
	(critics at:aRule) add: aCritic. 
	self updateBrowser! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:15'!
addFalsePositive: aCritic forRule: aRule

	(falsePositives includesKey: aRule) 
		ifFalse: [falsePositives at:aRule	put: IdentitySet new].
			
	(falsePositives at:aRule) add: aCritic. 
	
	self updateBrowser 	! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:15'!
addFalsePositiveClass: aClass 
	|fp|
	
	falsePositiveClasses add: aClass theNonMetaClass. 
	
	critics keysAndValuesDo: [:rule :criticss |
		fp := criticss select: [:critic |
			aClass = (critic isCompiledMethod 
				ifTrue: [critic methodClass theNonMetaClass]
				ifFalse: [critic])].
		fp do: [:each |
			self addFalsePositive: each forRule: rule ]
			
			].
	
	self updateBrowser	
! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/4/2013 14:13'!
addFalsePositiveRule: aRule forPackage: aPackage
	| fp |

	(falsePositiveRules includesKey: aPackage) 
		ifFalse: [falsePositiveRules at: aPackage put: Set new].
			
	(falsePositiveRules at:aPackage) add: (aRule class uniqueIdentifierName). 
	
	fp := (critics at: aRule ifAbsent: [^ self])
		select: [:c |  ((self packageOf: c) package name) = (aPackage packageName ) ].
		
	fp do: [:c | self addFalsePositive: c forRule: aRule]. 
	
	browser updateTree ! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:15'!
addToDo: aCritic forRule: aRule

	(toDos includesKey: aRule) 
		ifFalse: [toDos at:aRule	put: IdentitySet new].
			
	(toDos at:aRule) add: aCritic. 
	
	self updateBrowser! !

!CriticsCache methodsFor: 'accessing' stamp: 'SimonAllier 1/23/2013 13:48'!
browser: aCodeCritiicBrowser
	browser := aCodeCritiicBrowser ! !

!CriticsCache methodsFor: 'accessing' stamp: 'SimonAllier 2/5/2013 11:11'!
cacheChange
	^ change! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 2/5/2013 11:11'!
cacheChanged 
	change := true! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 2/5/2013 11:11'!
cacheNotChanged 
	change := false! !

!CriticsCache methodsFor: 'accessing' stamp: 'SimonAllier 1/23/2013 10:28'!
checker: aSmallLintChercker
	checker := aSmallLintChercker! !

!CriticsCache methodsFor: 'protocol' stamp: 'CamilloBruni 2/22/2013 22:41'!
criticsOf: aRule
	(aRule isNil "or: [aRule isEmpty]" )
		ifTrue: [ ^ {} ].
	
	^ aRule isComposite
		ifTrue: [ aRule leaves gather: [:rule | self criticsOf: rule]]
		ifFalse: [ critics at: aRule ifAbsent: [{}]]! !

!CriticsCache methodsFor: 'protocol' stamp: 'SimonAllier 1/28/2013 13:34'!
falsePositiveOf: aRule
	aRule ifNil: [ ^ {}].
	
	^ aRule isComposite
		ifTrue: [ aRule leaves gather: [:rule | self falsePositiveOf: rule]]
		ifFalse: [falsePositives at: aRule ifAbsent: [{}]]
	
	! !

!CriticsCache methodsFor: 'initialize-release' stamp: 'SimonAllier 1/31/2013 11:18'!
initCache

	checker rule leaves do: [:rule | 
		falsePositives at: rule put: (IdentitySet newFrom: (checker falsePositiveOf: rule)).
		toDos at: rule put: (IdentitySet newFrom:  (checker toDoOf: rule)).
		critics at: rule put: (IdentitySet newFrom:  rule critics) 
	].

	packages do: [:package |	
		falsePositiveRules at: package put: (checker rejectRulesOf: package) asSet .
		falsePositiveClasses addAll: (checker rejectClassesOf: package) asIdentitySet .
	]! !

!CriticsCache methodsFor: 'initialize-release' stamp: 'SimonAllier 2/5/2013 11:08'!
initialize
	
	falsePositives := Dictionary new.
	toDos := Dictionary new.	
	critics := Dictionary new.	
	falsePositiveRules := Dictionary new.
	falsePositiveClasses := IdentitySet new.
	change := false	
! !

!CriticsCache methodsFor: 'testing' stamp: 'SimonAllier 1/23/2013 11:27'!
isFalsePositive: aCritic forRule: aRule
	^ (self falsePositiveOf: aRule) includes: aCritic! !

!CriticsCache methodsFor: 'testing' stamp: 'SimonAllier 1/23/2013 11:50'!
isToDo: aCritic forRule: aRule
	^ (self toDosOf: aRule) includes: aCritic! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:15'!
itemRemoved: aItem
	critics values do: [:each | each remove: aItem ifAbsent: []].
	toDos values do: [:each | each remove: aItem ifAbsent: []].
	falsePositives values do: [:each | each remove: aItem ifAbsent: []].
	
	self updateBrowser  ! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 2/1/2013 12:55'!
logFalsePositiveClassInManifest
| manifestBuilder |
	
	packages do: [:package |
		manifestBuilder :=  BuilderManifest ofPackageNamed: package packageName.
		(manifestBuilder rejectClasses \ falsePositiveClasses) 
			do: [:cl |
				manifestBuilder removeRejectClass: cl]. 
		(falsePositiveClasses \ manifestBuilder rejectClasses) 			
			do: [:cl |
				manifestBuilder addRejectClass: cl]].

	! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 2/1/2013 12:56'!
logFalsePositiveInManifest
	|rId rV removeFp addFp|
	
	falsePositives keysAndValuesDo: [:rule :criticss | 
		rId := rule class uniqueIdentifierName.
		rV := rule class identifierMinorVersionNumber.
			
		removeFp :=  (checker falsePositiveOf: rule)  \ criticss.
		addFp :=  criticss \ (checker falsePositiveOf: rule).
		
		(removeFp groupedBy: [:each |  BuilderManifest of: each]) 
			keysAndValuesDo: [:manifestBuilder :value | 
						self removeAllCriticToFalsePositive: value 
							forRule: rule 
							on: manifestBuilder].
					
		(addFp groupedBy: [:each | BuilderManifest of: each]) 
			keysAndValuesDo: [:manifestBuilder :value | 
				(manifestBuilder rejectRules includes: (rule class uniqueIdentifierName))
					ifFalse: [
						self addAllCriticToFalsePositive: value  
							forRule: rule 
							on: manifestBuilder]]
		].
! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 2/1/2013 14:52'!
logFalsePositiveRulesInManifest
	| manifestBuilder |
	
	falsePositiveRules keysAndValuesDo: [:package :rules |
			manifestBuilder := BuilderManifest ofPackageNamed: package packageName.
			(manifestBuilder rejectRules \ rules) 
				do: [:rule |
					manifestBuilder removeRejectRule: rule]. 
			(rules \ manifestBuilder rejectRules) 			
				do: [:rule |
					manifestBuilder addRejectRule: rule]].
	


	! !

!CriticsCache methodsFor: 'protocol' stamp: 'SimonAllier 2/5/2013 11:20'!
logInManifest

	self cacheChange 
		ifFalse: [^ self].
	
	self logFalsePositiveRulesInManifest.
	self logFalsePositiveClassInManifest.
	self logFalsePositiveInManifest.
	self logToDosInManifest.
	self cacheNotChanged. 		

	self initCache
	! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 2/1/2013 12:57'!
logToDosInManifest
	|rId rV removeFp addFp|
	
	toDos keysAndValuesDo: [:rule :criticss | 
		rId := rule class uniqueIdentifierName.
		rV := rule class identifierMinorVersionNumber.
			
		removeFp :=  (checker toDoOf:  rule)  \ criticss.
		addFp :=  criticss \ (checker toDoOf: rule).
		(removeFp groupedBy: [:each | BuilderManifest of: each]) 
			keysAndValuesDo: [:manifestBuilder :value | 
						self removeAllCriticToToDo: value 
							forRule: rule 
							on: manifestBuilder].
					
		(addFp groupedBy: [:each | BuilderManifest of: each]) 
			keysAndValuesDo: [:manifestBuilder :value | 
				(manifestBuilder rejectRules includes: (rule class uniqueIdentifierName))
					ifFalse: [
						self addAllCriticToToDo: value  
							forRule: rule 
							on: manifestBuilder]]
		].
! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 1/25/2013 15:28'!
packageOf: aCritc
	aCritc isCompiledMethod 
		ifTrue: [MCWorkingCopy managersForClass: (aCritc methodClass) selector: (aCritc selector) do: [: package | ^ package  ]]	
		ifFalse: [MCWorkingCopy managersForClass: aCritc  do: [: package | ^ package  ]]	! !

!CriticsCache methodsFor: 'accessing' stamp: 'SimonAllier 1/31/2013 13:50'!
packages: aPackageEnv
	
	packages := aPackageEnv packages! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 1/25/2013 15:09'!
removeAllCriticToFalsePositive: aCollectionOfCritic forRule: aRule on: aManifestBuilder

	| ruleId versionId  |
	
	
	ruleId :=  aRule class uniqueIdentifierName.
	versionId :=   aRule class identifierMinorVersionNumber.
	(aManifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
		ifTrue: [aManifestBuilder removeAllFalsePositive: aCollectionOfCritic of: ruleId version: versionId].		
	 

	! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 1/25/2013 13:41'!
removeAllCriticToToDo: aCollectionOfCritic forRule: aRule on: aManifestBuilder

	| ruleId versionId  |
	
	ruleId :=  aRule class uniqueIdentifierName.
	versionId :=   aRule class identifierMinorVersionNumber.
	(aManifestBuilder hasToDoOf: ruleId version: versionId) 
		ifTrue: [ aManifestBuilder removeAllToDo: aCollectionOfCritic of: ruleId version: versionId].		
	

	! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:15'!
removeCritic: aCritic forRule: aRule

	(critics includesKey: aRule) 
		ifFalse: [^ self].
			
	(critics at:aRule) remove: aCritic ifAbsent: [^ self].
	self updateBrowser
	! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:16'!
removeFalsePositive: aCritic forRule: aRule

	(falsePositives includesKey: aRule) 
		ifFalse: [^ self].
		
	(falsePositiveClasses includes: (aCritic isCompiledMethod 
		ifTrue: [aCritic methodClass theNonMetaClass] 
			ifFalse: [aCritic]))  ifTrue: [^ self].
					
	(falsePositives at:aRule) remove: aCritic ifAbsent: [^ self].
	self updateBrowser
! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 1/25/2013 14:32'!
removeFalsePositiveClass: aClass
	|fp|
	
	
	falsePositiveClasses remove: aClass ifAbsent: [^ self]. 
	
	critics keysAndValuesDo: [:rule :criticss |
		fp := criticss select: [:critic |
			aClass = (critic isCompiledMethod 
				ifTrue: [critic methodClass theNonMetaClass]
				ifFalse: [critic])].
		fp do: [:each |
			self removeFalsePositive: each forRule: rule ]
			
			].
	browser updateTree.	
! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:16'!
removeFalsePositiveRule: aRule forPackage: aPackage
	| fp |
	
	(falsePositiveRules includesKey: aPackage) 
		ifFalse: [^ self].
	
	(falsePositiveRules at:aPackage) remove: (aRule class uniqueIdentifierName) ifAbsent: [^ self]. 

	fp := (critics at: aRule ifAbsent: [^ self])
		select: [:c | ((self packageOf: c) package name) = (aPackage packageName) and: [
				(falsePositiveClasses includes: (c isCompiledMethod 
					ifTrue: [c methodClass theNonMetaClass] 
					ifFalse: [c])) not]].

			
	fp do: [:c | self removeFalsePositive: c forRule: aRule]. 
	
	self updateBrowser ! !

!CriticsCache methodsFor: 'add/remove' stamp: 'SimonAllier 2/5/2013 11:16'!
removeToDo: aCritic forRule: aRule

	(toDos includesKey: aRule) 
		ifFalse: [^ self].
			
	(toDos at:aRule) remove: aCritic ifAbsent: [^ self].
	self updateBrowser
	! !

!CriticsCache methodsFor: 'protocol' stamp: 'SimonAllier 1/31/2013 11:20'!
replaceAll: oldMethod by: newMethod

	critics values do: [:each |  
		(each includes: oldMethod)
			ifTrue: [
				each remove: oldMethod.
				each add: newMethod ]].
		
	falsePositives values do: [:each |  
		(each includes: oldMethod)
			ifTrue: [
				each remove: oldMethod.
				each add: newMethod ]].

	toDos values do: [:each |  
		(each includes: oldMethod)
			ifTrue: [
				each remove: oldMethod.
				each add: newMethod ]].
	
	browser updateTree 	

	! !

!CriticsCache methodsFor: 'protocol' stamp: 'SimonAllier 1/28/2013 13:34'!
toDosOf: aRule
	aRule ifNil: [ ^ {}].
	
	^ aRule isComposite
		ifTrue: [ aRule leaves gather: [:rule | self toDosOf: rule]]
		ifFalse: [toDos at: aRule ifAbsent: [{}]]! !

!CriticsCache methodsFor: 'private' stamp: 'SimonAllier 2/5/2013 11:19'!
updateBrowser

	self cacheChanged.
	browser updateTree ! !

Object subclass: #ManifestManifestCriticBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
rejectClasses
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
rejectRules
^ #('MethodHasNoTimeStampRule')! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleBadMessageRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #perform:orSendTo: #false)) #'2013-02-01T15:29:51.915000005+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/6/2013 15:08'!
ruleCodeCruftLeftInMethodsRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #addCriticWithCommentToFalsePositive #false)) #'2013-02-06T15:08:32.572+01:00') #(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #addCriticWithCommentToToDo #false)) #'2013-02-06T15:08:32.572000001+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleCollectionMessagesToExternalObjectRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticsCache #addFalsePositiveRule:forPackage: #false)) #'2013-02-01T15:29:52.973000011+01:00') #(#(#RGMethodDefinition #(#CriticsCache #addToDo:forRule: #false)) #'2013-02-01T15:29:52.973000012+01:00') #(#(#RGMethodDefinition #(#CriticsCache #addFalsePositive:forRule: #false)) #'2013-02-01T15:29:52.973000013+01:00') #(#(#RGMethodDefinition #(#CriticsCache #addCritic:forRule: #false)) #'2013-02-01T15:29:52.973000014+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleEquivalentSuperclassMethodsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #perform:orSendTo: #false)) #'2013-02-01T15:29:56.387000008+01:00') #(#(#RGMethodDefinition #(#'SelectRuleBrowser class' #defaultSpec #true)) #'2013-02-01T15:29:56.387000009+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/6/2013 15:08'!
ruleGuardClauseRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #onWindowClosed #false)) #'2013-02-06T15:08:32.377+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleImplementedNotSentRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#'CommentFalsePositiveWindow class' #openOnCritic:onRule: #true)) #'2013-02-01T15:29:52.617000004+01:00') #(#(#RGMethodDefinition #(#CriticWorkingConfiguration #logInManifest: #false)) #'2013-02-01T15:29:52.617000005+01:00') #(#(#RGMethodDefinition #(#CriticsCache #addCritic:forRule: #false)) #'2013-02-01T15:29:52.617000006+01:00') #(#(#RGMethodDefinition #(#'CommentToDoWindow class' #openOnCritic:onRule: #true)) #'2013-02-01T15:29:52.617000007+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleMissingYourselfRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SelectRuleBrowser #nextAction #false)) #'2013-02-01T15:29:52.055000006+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleOnlyReadOrWrittenTemporaryRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticsCache #logFalsePositiveInManifest #false)) #'2013-02-01T15:29:52.762000008+01:00') #(#(#RGMethodDefinition #(#CriticsCache #logToDosInManifest #false)) #'2013-02-01T15:29:52.762000009+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleOnlyReadOrWrittenVariableRuleV1FalsePositive
^ #(#(#(#RGClassDefinition #(#CriticBrowser)) #'2013-02-01T15:29:52.299+01:00') #(#(#RGClassDefinition #(#SelectBrowser)) #'2013-02-01T15:29:52.299000001+01:00') #(#(#RGClassDefinition #(#SingleRuleCriticBrowser)) #'2013-02-01T15:29:52.301+01:00') #(#(#RGClassDefinition #(#ResetWindow)) #'2013-02-01T15:29:52.296000003+01:00') #(#(#RGClassDefinition #(#SelectPackageBrowser)) #'2013-02-01T15:29:52.296000002+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleReturnsIfTrueRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #iconFor: #false)) #'2013-02-01T15:29:51.740000004+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleSentNotImplementedRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SelectBrowser #setAddAllButtonModel #false)) #'2013-02-01T15:29:52.182000008+01:00') #(#(#RGMethodDefinition #(#SelectBrowser #setRemoveButtonModel #false)) #'2013-02-01T15:29:52.182000007+01:00') #(#(#RGMethodDefinition #(#CriticBrowser #methodAdded: #false)) #'2013-02-01T15:29:52.182000006+01:00') #(#(#RGMethodDefinition #(#SelectBrowser #setAddButtonModel #false)) #'2013-02-01T15:29:52.182000004+01:00') #(#(#RGMethodDefinition #(#SelectBrowser #items: #false)) #'2013-02-01T15:29:52.182000003+01:00') #(#(#RGMethodDefinition #(#SelectBrowser #setRemoveAllButtonModel #false)) #'2013-02-01T15:29:52.182000005+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleSubclassResponsibilityNotDefinedRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SelectBrowser #nextAction #false)) #'2013-02-01T15:29:53.049+01:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleTemporaryVariableCapitalizationRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #applyRules #false)) #'2013-02-01T15:29:53.129000006+01:00') #(#(#RGMethodDefinition #(#CriticBrowser #reapplyRule: #false)) #'2013-02-01T15:29:53.129000007+01:00') )! !
SingleRuleCriticBrowser initialize!
